(use test srfi-1)

(load-relative "../clojurian-syntax")
(import clojurian-syntax)

(test (vector 1 2)
      (doto (make-vector 2)
            (vector-set! 0 1)
            (vector-set! 1 2)))

(test 'foo (doto 'foo))

(test 1 (-> 99 (/ 11) (/ 9)))

(test '(1 2 3 4)
      (->* (values 1 2)
           (list 3)
           (append '(4))))

(test 7 (-> 10 (- 3)))
(test -7 (->> 10 (- 3)))

(test 9 (->> 1 (+ 2) (* 3)))

(test 9 (->> '(1 2 3)
             (map add1)
             (fold + 0)))

(test '((foo . 100) (bar . 200))
      (->>* (values '(foo bar) '(100 200))
            (map cons)))
